﻿Public NotInheritable Class xSleepAbout

    Private Sub xSleepAbout_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Set the title of the form.
        Dim ApplicationTitle As String

        Me.Left = xSleep.Left + 10
        Me.Top = xSleep.Top + 10

        If My.Application.Info.Title <> "" Then
            ApplicationTitle = "xSleep - Keeps Hard drives awake!"
        Else
            ApplicationTitle = System.IO.Path.GetFileNameWithoutExtension(My.Application.Info.AssemblyName)
        End If
        Me.Text = String.Format("About {0}", ApplicationTitle)
        ' Initialize all of the text displayed on the About Box.
        ' TODO: Customize the application's assembly information in the "Application" pane of the project 
        '    properties dialog (under the "Project" menu).
        Me.LabelProductName.Text = My.Application.Info.ProductName
        Me.LabelVersion.Text = String.Format("Version {0}", My.Application.Info.Version.ToString)
        Me.LabelCopyright.Text = My.Application.Info.Copyright
        Me.LabelCompanyName.Text = My.Application.Info.CompanyName
        Me.TextBoxDescription.Text = "An application to keep multiple hard drives awake and spinning." + Environment.NewLine + Environment.NewLine + "Note: Multi-Disk cannot target C:\." + Environment.NewLine + Environment.NewLine + "In theory you could keep Network shares alive as well. Accepts CMD '/m' sets Autorun and automatic minimise."
    End Sub

    Private Sub OKButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OKButton.Click
        Me.Close()
    End Sub

   
End Class
